<template>
  <v-form>
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model.number="item.totalPrice"
            :error-messages="totalPriceErrors"
            :label="$t('totalPrice')"
            step="0.1"
            @input="$v.item.totalPrice.$touch()"
            @blur="$v.item.totalPrice.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.renter"
            :items="renterSelectItems"
            :error-messages="renterErrors"
            :no-data-text="$t('No results')"
            :label="$t('renter')"
            item-text="name"
            item-value="@id"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <!-- todo : fix the dateTime format, not supported by default on vuetify -->
        <v-col cols="12" sm="6" md="6">
          <InputDate
            v-model="item.updatedAt"
            :label="$t('updatedAt')"
            :error-messages="updatedAtErrors"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-combobox
            v-model="item.composes"
            :items="composesSelectItems"
            :error-messages="composesErrors"
            :no-data-text="$t('No results')"
            :label="$t('composes')"
            multiple
            item-text="name"
            item-value="@id"
            chips
          />
        </v-col>
      </v-row>
      
    </v-container>
  </v-form>
</template>

<script>
import has from 'lodash/has';
import { validationMixin } from 'vuelidate';
//import { required } from 'vuelidate/lib/validators';
import { mapActions } from 'vuex';
import { mapFields } from 'vuex-map-fields';
import InputDate from '../InputDate';
import { date } from '../../validators/date';

export default {
  name: 'OrderForm',
  mixins: [validationMixin],
  components: {
    InputDate,
  },
  props: {
    values: {
      type: Object,
      required: true
    },

    errors: {
      type: Object,
      default: () => {}
    },

    initialValues: {
      type: Object,
      default: () => {}
    }
  },
  mounted() {
      this.renterGetSelectItems();
      this.composesGetSelectItems();
  },
  data() {
    return {
        totalPrice: null,
        renter: null,
        updatedAt: null,
        composes: null,
    };
  },
  computed: {
      ...mapFields('user', {
        renterSelectItems: 'selectItems'
      }),
      ...mapFields('compose', {
        composesSelectItems: 'selectItems'
      }),

    // eslint-disable-next-line
    item() {
      return this.initialValues || this.values;
    },

    totalPriceErrors() {
      const errors = [];

      if (!this.$v.item.totalPrice.$dirty) return errors;

      has(this.violations, 'totalPrice') && errors.push(this.violations.totalPrice);


      return errors;
    },
    renterErrors() {
      const errors = [];

      if (!this.$v.item.renter.$dirty) return errors;

      has(this.violations, 'renter') && errors.push(this.violations.renter);


      return errors;
    },
    updatedAtErrors() {
      const errors = [];

      if (!this.$v.item.updatedAt.$dirty) return errors;

      has(this.violations, 'updatedAt') && errors.push(this.violations.updatedAt);


      return errors;
    },
    composesErrors() {
      const errors = [];

      if (!this.$v.item.composes.$dirty) return errors;

      has(this.violations, 'composes') && errors.push(this.violations.composes);


      return errors;
    },

    violations() {
      return this.errors || {};
    }
  },
  methods: {
      ...mapActions({
        renterGetSelectItems: 'user/fetchSelectItems'
      }),
      ...mapActions({
        composesGetSelectItems: 'compose/fetchSelectItems'
      }),
  },
  validations: {
    item: {
      totalPrice: {
      },
      renter: {
      },
      updatedAt: {
        date,
      },
      composes: {
      },
    }
  }
};
</script>
